// Commented because even with this do not works in Edge - and cannot open devtools
// https://stackoverflow.com/questions/48623669
// window.chrome = window.chrome || window.browser;
// Edge has only window.browser

// TODO add contextMenus item: `Add to the feed`

// TODO prepend global variables with g, like gAudio.
let gTimeStartedWaitingFirstAudio = 0,
    audio = [],
    audioCurrent = null,
    audioCurrentFeedEntityId = null,

    isIcoAnimating = false,
    isRewinding = false,
    isPreparingPlaying = false,
    isAddingToFeedIds = [],

    audioNotification = new Audio(chrome.runtime.getURL('audio/sirius.ogg'));
audioNotification.volume = 0.3;


/**
 * We have this function because in Firefox inpossible to alert
 * from background page.
 *
 * `Escaped` for multiline text - without that can not print.
 */
function _alert(text) {
    chrome.tabs.executeScript(
        {
            'code': `alert(\`${text}\`)`
        },
        _ => chrome.runtime.lastError &&
            console.log(
                'User tried to add to the feed internal browser page, this is normal behaviour for us to do nothing,',
                'original error:', chrome.runtime.lastError)
    );
}

function _alertError() {
    _alert('Server Error. We have been notified about it. Sorry!\n\n' +
    'We are working on fixing this problem at the moment. Please, try again later!\n\n' +
    'We appreciate you are with us and we want to make sure our product brings joy and satisfaction to users! Stay in touch!');
}

function _buildContextMenu() {
    console.log('Build context menu');
    chrome.storage.sync.get('lang', storageSync =>
        // TODO read lang from store only - persist that value on install/update?
        _getMessages(storageSync['lang'] || navigator.language.replace('-', '_'))  // eslint-disable-line no-undef
            .then(messages =>
                chrome.contextMenus.create({
                    'title': messages['contextMenu_addToFeed']['message'],
                    'id': 'root',
                    'contexts': ['all']
                }, _ => {
                    if (chrome.runtime.lastError)
                        console.log('Context menu item already exists, just saying');
                })
            )
    );
}
_buildContextMenu();

chrome.contextMenus.onClicked.addListener(_ => {
    _getActiveTab(tabActive => {  // eslint-disable-line no-undef
        if (tabActive.url.match(/^chrome|^about(?!:reader)/)) {
            // Opera with 'chrome://' too; Firefox: it is possible to inject into reader page
            _alert('Impossible to listen to browsers pages');
            // Firefox user will not see this alert, fuck with it (Valera said)
        } else if (
            tabActive.url.match(
                /^https:\/\/(chrome.google.com\/webstore|addons.mozilla.org|addons.opera.com)/
            )
        ) {
            _alert('Impossible to listen to extension store pages');
            // Firefox user will not see this alert, fuck it (Valera said)
        } else {  // ok it is usual page - let add it to feed
            console.log('Event listener on tts from context menu: before injecting script');

            chrome.tabs.insertCSS({'file': 'progress.css'});
            chrome.tabs.insertCSS({'file': 'snackbar.css'});

            chrome.tabs.detectLanguage(lang =>
                /* Detect language before content script - because user may switch the tab
                 * while content script will fetch Wikipedia. */
                injectScript({
                    'operation': 'addToFeed',
                    'time': Date.now() / 1000 | 0,
                    'url': tabActive.url,
                    'favIconUrl': tabActive.favIconUrl,
                    'title': tabActive.title,
                    'tabId': tabActive.id,
                    'lang': lang !== 'und' ? lang : ''
                })
            );
        }
    });
});

class AudioExtended extends Audio {
    play() {

        audioCurrent = this;

        // Return Promise
        return super.play();
    }
}

function showMessagePay() {
    if (window.confirm(  // TODO i18n
        'Nice job! We hope you found Intelligent Speaker\n' +
        'useful. You used all available time\n' +
        'during beta test.\n\n' +

        'Would like to continue listening texts?\n' +
        'For that push OK - this will open your default mail app\n' +
        'with our prefilled email address - just say\n' +
        '\'I want MORE free listening time.\'\n' +
        'Make sure the email you are contacting us\n' +
        'matches the one you are signed in\n\n' +

        'Also you are welcome to give any feedback!\n' +
        'Feel free to inform us about\n' +
        'incorrect text reading on some pages.\n' +
        'Or maybe you need some\n' +
        'additional functionality?')) {

        /** Neither document.location nor `document.createElement('a'); a.click()` because
        * this does not open mail app - maybe because we inside event page.
        *
        * Now this open new empty tab and open default email app. TODO open
        * https://intelligent-speaker.com?send-email
        * where js will trigger on param -
        * against empty page and for advertisement. */
        window.open('mailto:support@intelligent-speaker.com?subject=Add me more time');  // TODO i18n
        // TODO close this tab after few seconds - get using chrome.runtime.query()
    }
    // TODO use text commented above when we will accept payments
}

/**
 * https://developer.chrome.com/extensions/runtime#type-OnInstalledReason
 */
chrome.runtime.onInstalled.addListener(details => {
    if (details.reason === 'install') {
        // TODO confirm() that we are going to auth
        goToAuth();    // eslint-disable-line no-undef
        /** Duplicated with common.js - user can uninstall because do not want to auth;
         */
        chrome.runtime.setUninstallURL(
            'https://docs.google.com/forms/d/e/1FAIpQLSdDNyd3COJzZEw9sHXE34Y2Ercrq0klL1hCn0Or2mZapG7UQw/viewform?usp=pp_url&entry.839337160&entry.1314511419'
        );
    } else if (details.reason === 'update') {

        // TODO remove this block when all user migrated to the version from January 2017 - with Cognito and podcast button
        chrome.storage.sync.get(storageSync => {
            if (storageSync['state'] || storageSync['id_token']) {
                // if already updated from version with Playlist/History and without podcasts (September 2017)
                return;
            }
            const feedEntities = {};
            for (const key in storageSync) {
                if (key.startsWith('listEntity_')) {
                    const feedEntity = storageSync[key];
                    const hashArticle = Object.keys(feedEntity['hashes'])[0];
                    feedEntity['hashArticle'] = hashArticle;
                    feedEntity['hashesChunks'] = feedEntity['hashes'][hashArticle];
                    feedEntity['isAudioFromPublicBucket'] = true;  // for backward compatibility

                    delete feedEntity['hashes'];
                    delete feedEntity['isInPlaylist'];
                    feedEntities[key.replace(/\D+/, '')] = feedEntity;
                    chrome.storage.sync.remove(key);
                }
            }
            console.log(feedEntities);
            chrome.storage.sync.set(feedEntities, resp => console.log(resp));
            chrome.storage.sync.remove('clientCode');
        });

    }
});


chrome.runtime.onMessage.addListener(message => {
    console.log('eventPage: message:', message);

    /** Called every time when popup is opened - to reinit state -
    * on popup close lose state */
    switch (message['fromPopup']) {
    case 'getStatus':
        chrome.runtime.sendMessage({
            'toPopup': {
                'isPaused': audioCurrent ? audioCurrent.paused: null,
                'hasNextChunk': audio.length && audioCurrent && audioCurrent.dataset['index'] < audio.length - 1,
                'audioCurrentFeedEntityId': audioCurrentFeedEntityId,
                'isPreparingPlaying': isPreparingPlaying,
                'isAddingToFeedIds': isAddingToFeedIds
            }
        });
        break;

    case 'addToFeed':
        isAddingToFeedIds.push(message['time']);

        // Draw context through the content script because during fetching from Wikipedia this event page may be unloaded
        injectScript({
            'operation': message['fromPopup'],
            'time': message['time'],
            'url': message['url'],
            'favIconUrl': message['favIconUrl'],
            'title': message['title'],
            'lang': message['lang']
        });
        break;

    case 'playFromFeed':
        if (audioCurrent) {
            stop();
        }
        playFromFeed(message['id']);
        break;

    case 'togglePlayedStatus':
        _setPlayedStatusInStorages(
            message,
            message['id'],
            message['val']
        );
        break;

    case 'resume':
        resume();
        break;

    case 'pause':
        pause();
        break;

    case 'stop':
        stop(false);
        break;

    case 'rewindBack':
        rewindBack();
        break;

    case 'fastForward':
        fastForward();
        break;

    case 'alterPlaybackRate':

        // When started playing from feed and still fetching for the first thunk.
        if (audioCurrent)
            audioCurrent.playbackRate = message['value'];

        audio.forEach(a => {
            // https://developer.mozilla.org/en-US/Apps/Fundamentals/Audio_and_video_delivery/WebAudio_playbackRate_explained
            /** Alter two attributes - because defaultPlaybackRate applied to ended and not started
             * while playbackRate applied to switched from tracks - on scrolling through audio using prev/next buttons. */
            a.playbackRate = a.defaultPlaybackRate = message['value'];
        });
        break;

    case 'buildContextMenu':
        _buildContextMenu();
        break;
    }

    if (message['fromPopup'])
        return;

    // Add to feed
    // This is the message from content script
    chrome.storage.sync.get(storageSync => {

        const callback = jsonTokens => addToFeed(
            Object.assign(storageSync, jsonTokens),
            message
        );

        const catchCallback = e => {
            _alert('Internet connection error');
            console.log(e);

            isPreparingPlaying = false;
            audioCurrentFeedEntityId = null;

            isIcoAnimating = false;
            removeStubFromFeed(message['time']);
            chrome.runtime.sendMessage({'toPopup': {
                'playingFinished': true,
                'isAutomaticStop': true,
                'removeStubFromFeed': true}
            });
        };

        if (storageSync['id_token']) {
            _keepTokenFresh(storageSync)  // eslint-disable-line no-undef
                .then(jsonTokenNew => callback(jsonTokenNew))
                .catch(e => catchCallback(e));
        } else if (storageSync['state']) {
            /** TODO after exchanging id_token can be expired (when first use after hours after installing) -
                 here must be comparing of `exp` too - extract checking to func */
            _getInitData(storageSync['state'])  // eslint-disable-line no-undef
                .then(jsonTokenNew => _keepTokenFresh(jsonTokenNew))  // eslint-disable-line no-undef
                // May be expired from DynamoDB

                .then(jsonTokenNew => callback(jsonTokenNew))
                .catch(e => catchCallback(e));  // Offline or ApiGateway unavailable
        } else {
            // TODO add confirm()?
            goToAuth();  // eslint-disable-line no-undef
            stop();
        }
    });

});


/**
* Why not extract text from html on client?
* Because when we will have extension for a few browsers, iOS app and Android app -
* will be difficult to update selectors for specific pages - update for all clients and wait of review from stores.
*
* Minour pros of server side extractor:
* 1 Better battery of user, faster install.
* 2. Against stealing of code.
*
* Cons: Money for Lambda
*/
function addToFeed(storageSync, args) {
    console.log(arguments.callee.name, arguments);

    // Handled page from Firefox reader
    const urlOfPage = decodeURIComponent(args['url']).replace(/^about:reader\?url=/, '');

    // Do not use result from POST for playing audio because
    // the only way to do that is to create a blob and after that create a Link from blob
    // but that discard native audio streaming and
    // increase wasting time for user
    // https://stackoverflow.com/questions/44482967/mediasource-does-not-support-ogg-audio
    // https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API
    // https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API/Using_Fetch
    // https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API/Basic_concepts
    fetch('https://mjqj47yt17.execute-api.us-east-1.amazonaws.com/test', {
        'method': 'POST',
        'headers': {
            'Authorization': storageSync['id_token'],
            'Content-Type': 'application/json'
        },    // ApiGateway will validate this token from Cognito
        'body': JSON.stringify({  // without JSON.stringify() body will be empty
            'utc': args['time'],
            'title': args['title'],
            urlOfPage,
            'favIconUrl': args['favIconUrl'],
            'lang': args['lang'],
            'stringForVoicing': args['stringForVoicing'],
            'operation': args['operation']
        })
    }).then(fromBackend => {
        // TODO replace then() to the await and decrease intendantion?
        if (fromBackend.ok) {
            isAddingToFeedIds = [];
            return fromBackend.json().then(function(fromBackend) {

                if (fromBackend['status_code'] === 'PAYMENT_REQUIRED') {
                    showMessagePay();
                    removeStubFromFeed(args['time']);
                }

                if (!fromBackend['presigned_urls']) {
                    console.log('No presigned urls from backend');
                    stop();

                    /** ApiGateway return such dict in case of error in Lambda:

                            {"errorMessage": "local variable 'my_variable' referenced before assignment",
                             "errorType": "UnboundLocalError",
                             "stackTrace": [
                                 ["/var/task/extractor.py", 187, "extract_article", "my_variable.append(something)"]]}

                            TODO: setup ApiGateway to handle error from Lambda to generic error BACKEND_ERROR -
                                 against exposing our backend code
                     */

                    // server do not extract text from html, for example empty page
                    if (fromBackend['status_code'] === 'TEXT_LENGTH_IS_ZERO') {
                        _alert('We can not extract text from this page :(\n\n' +
                           'If you think that we should read aloud something here - we want to get your feedback.');
                        // TODO i18n

                        /**
                         * For development only when popup is always open
                         * (when devtools opened).
                         * User experience: alert closes popup
                         * and we do not need to alter it state
                         * because it is already unloaded.
                         */
                        chrome.runtime.sendMessage({'toPopup': {
                            'playingFinished': true,
                            'removeLastItemFeed': true}
                        });
                        removeStubFromFeed(args['time']);
                    }

                    if (fromBackend['errorMessage']) {
                        //TODO upgrade extension and try again, if possible?
                        _alertError();
                        console.log(fromBackend);
                        chrome.runtime.sendMessage({'toPopup': {
                            'playingFinished': true,
                            'isAutomaticStop': true}
                        });
                    }

                    args['tabId'] &&
                        _endProgressOnPage(args['tabId'], storageSync);

                    return;
                }

                // id is a pure int without a namespace like `feedEntity_` because chrome sync storage is only 100kb
                // https://developer.chrome.com/apps/storage#property-sync
                console.log(arguments.callee.name, 'id for getting data from chrome storage:', args['time']);
                // Update cache - we use cache for case when user closed and opened popup while POST still in process
                const {hashArticle, lenChunks} = _getMinimalUrlRepresentation(fromBackend['presigned_urls']);
                chrome.storage.sync.set({
                    [args['time']]: {
                        'url': urlOfPage,  // TODO rename url to urlOfPage like in db?
                        'favIconUrl': args['favIconUrl'],
                        'title': args['title'],
                        hashArticle,
                        lenChunks
                    }
                });
                chrome.runtime.sendMessage(
                    {
                        'toPopup': 'addedToFeed',
                        'hashArticle': hashArticle,
                        'lenChunks':   lenChunks
                    }
                );

                if (args['tabId'])
                    // tabId is only when from context menu -
                    _endProgressOnPage(args['tabId'], storageSync, 'snackbar_addedToFeed');
            });
        }
        _alertError();
    }).catch(e => {
        console.log(e);
        console.log('urlOfPage:', args['url']);
        console.log('title:', args['title']);
        console.log('stringForVoicing:', args['stringForVoicing']);
        _alert('Server unavailable, please try again');
        _endProgressOnPage(args['tabId'], storageSync);

        // Unblock buttons
        chrome.runtime.sendMessage({
            'toPopup': {
                'playingFinished': true
            }
        });

        isIcoAnimating = false;
        audioCurrentFeedEntityId = isPreparingPlaying = null;
        removeStubFromFeed(args['time']);
    });
}

function _endProgressOnPage(tabId, storageSync, messagePlaceholder) {
    console.log(arguments.callee.name, arguments);

    _getMessages(storageSync['lang'] || navigator.language.replace('-', '_'))  // eslint-disable-line no-undef
        .then(messages =>
            chrome.tabs.sendMessage(
                tabId,
                {'snackbar--html': messagePlaceholder && messages[messagePlaceholder]['message']}  // eslint-disable-line no-undef
            )
        );
}

function playFromFeed(idFeedEntity) {
    console.log('playFromFeed(): idFeedEntity:', idFeedEntity);
    isPreparingPlaying = true;
    audioCurrentFeedEntityId = idFeedEntity;
    audioNotification.play();
    badgeAnimationToggle(); // user can wait due to the network problem
    chrome.storage.sync.get(storageSync => {
        const feedEntity = storageSync[idFeedEntity];

        /** TODO at December 2017 move public chunks from old bucket to the current private
         * when we will know subs (uuids) of users from Cognito (mathed with email)
         * and remove this code for backward compatibility.
         */
        if (feedEntity['isAudioFromPublicBucket']) {
            buildAudioChain(
                _buildUrlsForOldPublicChunks(feedEntity['hashArticle'], feedEntity['hashesChunks']),
                feedEntity['favIconUrl'],
                storageSync
            );

        } else {
            /** Always get new presigned urls although we can store them in 'big' local storage (5 mb)
             *  and check expiration date - because user can pause and continue to listen
             *  after an hour - for such case at longest as possible urls are better.
             *  Second reason - for simplicity of code -
             *  against a few dozen of lines
             */
            _keepTokenFresh(storageSync).then(jsonTokenNew => _getPresignedUrls(  // eslint-disable-line no-undef
                feedEntity['hashArticle'],
                feedEntity['lenChunks'],
                jsonTokenNew['id_token'],
                idFeedEntity)
                .then(urls => buildAudioChain(
                    urls,
                    feedEntity['favIconUrl'],
                    storageSync
                ))
            );

            feedEntity['isNew'] &&
                _setPlayedStatusInStorages(storageSync, idFeedEntity, false);
        }
    });
}

function buildAudioChain(presignedUrls, favIconUrl, storageSync) {
    console.log('buildAudioChain() arguments:', arguments);
    // while user listen for the first sentence - prepare all other audious
    for (let i = 0; i < presignedUrls.length; i++) {
        audio[i] = new AudioExtended();
        /** Define without src and add src later because may be the case when
         *  first chunk is ended and code below faced with 'ended' event
         *  where tried to play or attach event to play when 'canplay'
         *  and this HTMLMediaElement must already exists -
         *  we can attach event without src.
         *
         *  Without such separation you will face with
         *  `Cannot read property 'readyState' of undefined`.
         */

        /** We use here setTimeout() for the case when all chunks already on S3
         *  and cache of the browser is not used (because presigned urls always new -
         *  for chunks on S3 even setted header 'no-store')
         *  for example user listen from list feed - in such case readyState > 1
         *  for all chunks and browser fetch many chunks in parallel -
         *  because of that highly delayed playing of the article
         */
        gTimeStartedWaitingFirstAudio = Date.now();
        setTimeout(
            _ => {
                if (!audio[i])
                    // After stop().
                    // This is just against Uncaught TypeError in js console.
                    return;

                audio[i].src = presignedUrls[i];
                // https://developer.mozilla.org/en-US/Apps/Fundamentals/Audio_and_video_delivery/WebAudio_playbackRate_explained
                audio[i].defaultPlaybackRate = storageSync['playbackRate'];
                /** Here we use global variable for playback rate instead of parameter because
                 *  user can alter playback rate when not all audio objects was constructed. */
                // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/playbackRate
                audio[i].dataset['index'] = i;
                playFirstChunkAndAttachAudioEvents(i, presignedUrls.length, favIconUrl, storageSync);
            },
            i * (i < 3 ? 300 : 9000)
            // TODO upgrade this naive approach to the array pull where always downloading only few chunks
        );

    }
}


function playFirstChunkAndAttachAudioEvents(j, countChunks, favIconUrl, storageSync) {
    if (j === 0)
        console.log('j:', j, 'first chunk: network state:', audio[0].networkState, 'ready state:', audio[0].readyState);

    if (audio[j].readyState === 4) {
        // `HAVE_ENOUGH_DATA: enough data is available — and the download rate is high enough`
        // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/readyState
        if (j === 0) {
            console.log('before playing first chunk: audio[0].playbackRate:', audio[j].playbackRate);
            audio[0].play().then(_ => {  // start the playing chain
                isIcoAnimating = false;
                chrome.runtime.sendMessage({
                    'toPopup': {
                        'playingStarted': true,
                        'audioCurrentFeedEntityId': audioCurrentFeedEntityId,
                        'hasNextChunk': audio[1] && audio[1].readyState === 4
                        // Short texts may consists only from one chunk
                    }
                });
                _doNotSleep();
                isPreparingPlaying = false;
            });
        } else {
            console.log('j:', j);
            console.log('audioCurrent.dataset["index"]:', audioCurrent ? audioCurrent.dataset['index'] : null);
            if (j - 1 == (audioCurrent && audioCurrent.dataset['index'])) {
                console.log('Next chunk is ready');
                chrome.runtime.sendMessage({
                    'toPopup': {
                        'nextChunkReady': true
                    }
                });
            }
        }

        // audio events: https://developer.mozilla.org/en/docs/Web/Guide/Events/Media_events
        audio[j].addEventListener('ended', _ => {
            console.log('chunk ended, i:', audioCurrent.dataset['index']);
            if (j < countChunks - 1) { // if has next
                if (audio[j+1].readyState === 4) {
                    if (isRewinding) {
                        console.log('Prevented playing next chunk while rewinding');
                        return;
                        /** Against case when user hear two chunks in parallele because of starting the next chunk
                         * while switching to the previous. */
                    }
                    audio[j+1].play();
                    updateProgressBar();
                } else {
                    audio[j+1].addEventListener('canplay', _ => {
                        // 'canplay': corresponds to the HAVE_ENOUGH_DATA readyState
                        // https://developer.mozilla.org/en-US/docs/Web/Guide/Events/Media_events

                        // If not rewinded to another chunk while we waited for `canplay`
                        if (audioCurrent.dataset['index'] == j &&
                            !isRewinding)
                            audio[j+1].play();
                    });
                }
            }
            if (j === countChunks - 1) { // last chunk ended - silence begin
                chrome.storage.sync.get(_storageSync => {
                    // Handle switching here instead of popup because popup may not exists now.
                    // Current storage instead of cache against catching message from popup about updated.
                    if (_storageSync['isContinuousPlaying'])
                        _playNextItem(audioCurrentFeedEntityId, storageSync);
                    else
                        stop();
                });
            }
        });
    } else {  // still unavailable by the link with audio (403 Forbidden because bucket is non-public)
        // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/networkState
        // https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/readyState
        if (audio[j].networkState === 3)  // NETWORK_NO_SOURCE
            audio[j].src = audio[j].src; // trigger GET request
        // You can not attach event `canplay` without reiniting of src - because on temp 404 browser no longer tries
        if (!j && Date.now() - gTimeStartedWaitingFirstAudio > 30000) {
            _clearAllTimeouts();
            stop();
            _alertError();
            return;
        }

        setTimeout(_ => {
            playFirstChunkAndAttachAudioEvents(j, countChunks, favIconUrl, storageSync);
            // recursion - try fetch audio again (correct case - still not uploaded to S3)
        }, j * (j < 3 ? 300 : 9000) + 10);
        // Listen first chunks as fast as possible and do not try to download all hundread of chunks at once.
        /** Without +10 impossible to cancel all timeouts on error,
        /* and also little less pressure for the first audio chunk. */
    }
}

function _playNextItem(_audioCurrentFeedEntityId, storageSync) {
    const itemFeedNext = _getNextFeedEntity(_audioCurrentFeedEntityId, storageSync);
    if (itemFeedNext) {
        playFromFeed(itemFeedNext['id']);
    } else stop();
}

/**
 * /email/ just as example of API Gateway ability to consume nested path arguments.
 * It is mean that in API Gateway in body mapping template we can get /all/values/from/path/
 * but in such case we extract email from Cognito credentials lieu of the path args
 * because client hijacker can send any email.
 */
async function _setPlayedStatusInStorages(storageSync, id, val) {
    const feedItem = storageSync[id];
    feedItem['isNew'] = val;
    chrome.storage.sync.set({
        // id in brackets because this is not a string but reference to value from variable.
        [id]: storageSync[id]
    });

    const storageSyncWithFreshIdToken = await _keepTokenFresh(storageSync);  // TODO move all function from common.js to eventPage.js - against duplication in ram
    fetch(`${stageUrl}history/email/${id}`, {
        'method': 'PUT',
        'headers': {
            'Authorization': storageSyncWithFreshIdToken['id_token']
        },
        'body': String(val)
    });
}


/** 'Next' mean older than the current.
 *
 *  TODO migrate history storage to the IndexedDB and store history in Array
 *  for simpler getting of the next item without sotring? */
function _getNextFeedEntity(_audioCurrentFeedEntityId, storageSync) {
    const idsOrdered = Object.keys(storageSync)
        .filter(key => key.match(/\d/))
        .sort((a, b) => a > b);  // From new to old, like in popup.js
    const indexCurrent = idsOrdered.indexOf(_audioCurrentFeedEntityId);
    const idNext = idsOrdered[indexCurrent - 1];  // -1 get older feed item
    if (idNext)
        return {...storageSync[idNext], ...{'id': idNext}};
}


/**
 * We can not store presigned urls because chrome storage has a limit 8kb per item -
 * and big article on Wikipedia will throw an error without this function.
 *
 * Example of presigned url: https://intelligentspeaker.s3.amazonaws.com/
 * f4cfd4a8-0e94-4287-8c5e-1b01538dd2a1/c83626c8a374eed9615e17e958421b17/0?...args...
 * sub (uuid of user in Cognito) / hash of article / id of chank
 *
 * @see {@link https://developer.chrome.com/apps/storage}
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/map}
 */
function _getMinimalUrlRepresentation(presignedUrls) {
    return {
        'hashArticle': presignedUrls[0].split('/')[4],
        'lenChunks':  presignedUrls.length
    };
}


/**
 * Now every play from list call lambda for new presigned urls.
 * TODO for offline playing store blobs in IndexedDB.
 *
 * @see {@link https://developer.chrome.com/apps/storage | About storage limits}
 */
async function _getPresignedUrls(hashArticle, lenChunks, idToken) {
    console.debug('_getPresignedUrls():', arguments);
    try {
        const resp = await fetch(`${stageUrl}get-presigned-urls`, {  // eslint-disable-line no-undef
            'method': 'POST',
            'headers': {
                'Authorization': idToken,
                'Content-Type': 'application/json'},
            'body': JSON.stringify({hashArticle, lenChunks})
        });
        const resp_json = await resp.json();
        return resp_json;
    } catch(e) {
        console.error(e);
        _alertError();
        stop();
    }
}

/**
 * For backward compatibility.
 * TODO remove this function at year 2018 when all users will be at the newer version.
 */
function _buildUrlsForOldPublicChunks(hashArticle, hashesChunks) {
    return hashesChunks.map(hashChunk =>
        `https://s3.amazonaws.com/intelligentspeaker--audio/${hashArticle}/${hashChunk}`);
}


function badgeAnimationToggle() {    // TODO rename to badgeAnimationStart and for stopping use `isIcoAnimating = false?`
    console.log('badgeAnimationToggle()');
    chrome.browserAction.setBadgeBackgroundColor({'color': 'gray'});
    isIcoAnimating = !isIcoAnimating;
    if (isIcoAnimating) {
        (function replaceIco() {
            chrome.browserAction.getBadgeText({}, text => {
                if      (text === '.  ' || !text)       chrome.browserAction.setBadgeText({'text': ' . '});
                else if (text === ' . ')                chrome.browserAction.setBadgeText({'text': '  .'});
                else if (text === '  .')                chrome.browserAction.setBadgeText({'text': '.  '});
            });
            if (isIcoAnimating) {
                window.setTimeout(_ => {
                    replaceIco();
                }, 700);
            } else {
                window.setTimeout(_ => {
                    // Without filtering of short audio can set `||` when audio is finished and related code will not clear it.
                    try {
                        chrome.browserAction.setBadgeText(
                            {'text': (audio.length > 1 || (audio && audio[0].duration > 3)) ? '||' : ''});
                    } catch (e) { // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypeError
                        // case: audio existed but at next checking already not
                        if (e.message === 'Cannot read property \'duration\' of undefined') {
                            chrome.browserAction.setBadgeText({'text': ''});
                        }
                    }
                    chrome.browserAction.setBadgeBackgroundColor({'color': 'green'});
                }, 710);    // little more than 700
            }
        })();
    }
}


function rewindBack() {
    if (isRewinding) {
        return;
    }
    isRewinding = true;

    audioCurrent.pause();
    audioCurrent.currentTime = 0;    // for when this chunk will play again - start with start

    audio[audioCurrent.dataset['index'] - 1]
        .play()
        .then(_ => {
            isRewinding = false;
            updateProgressBar(true);
        });
}


function fastForward() {
    if (isRewinding) {
        return;
    }
    isRewinding = true;

    audioCurrent.pause();
    audioCurrent.currentTime = 0;  // for when this chunk will play again - start with start

    audio[Number(audioCurrent.dataset['index']) + 1]
        .play()
        .then(_ => {
            isRewinding = false;
            updateProgressBar();
        });
}


function updateProgressBar(isRewindedBack=false) {
    const progressNum = audioCurrent.dataset['index'] * 100 / audio.length | 0;
    _sendMessageToPopupProgress(progressNum, isRewindedBack);
}


/**
 *  @param {boolean} isRewindedBack - firstly I tried generic approach using audioNext but
 *  look like some defect of the Chrome - sometimes on rewind first or second chunk
 *  downgrages his readyState from 4 to 1.
 */
function _sendMessageToPopupProgress(progressNum, isRewindedBack) {
    console.debug('_sendMessageToPopupProgress, progressNum: %s; isRewindedBack: %s', progressNum, isRewindedBack);

    const audioNext = audio[Number(audioCurrent.dataset['index']) + 1];
    // May not exists yet - because we create audio objects not all at once but using setTimeout in loop.
    // hasNextChunk determines if fastForward button on the UI will be unblocked

    if (audioNext)
        /**
         * Here you will see for example
         * 4 1 4 4 4 4 4
         * When we rewind back from index number 5.
         * Looks like defect of the Chrome -
         * readyState of the second chunk must be 4 because it already was fully listened
         */
        console.table(audio.map(a => new Object({'readyState': a.readyState, 'networkState': a.networkState})));
    else
        console.debug('No next chunk');

    chrome.runtime.sendMessage({
        'toPopup': {
            'progress': progressNum,
            'hasNextChunk': isRewindedBack || (audioNext ? audioNext.readyState === 4 : false)
        }
    });
}


/**
 * Content script get html or text from page, maybe using some API,
 * for example when Wikipedia.
 * @see {@link https://developer.chrome.com/extensions/tabs#method-executeScript}
 *
 * Firstly we pass args and after that inject the file -
 * this is the only way to inject script with variables.
 */
function injectScript(args) {
    // Without stringify will print [object Object]
    chrome.tabs.executeScript({'code': `args = ${JSON.stringify(args)}`}, _ => {
        if (chrome.runtime.lastError &&
            chrome.runtime.lastError.message.startsWith(
                'Cannot access contents of the page')) {
            // Looks like this problem only when opened `chrome://extensions`?
            // TODO try again?
            _getActiveTab(tabActive => {  // eslint-disable-line no-undef
                console.error(
                    '%cBug of the Chromium: `Can not access contents of the page`, current tab:', 'font-size: large',
                    tabActive);
            });
        } else {
            chrome.tabs.executeScript({'file': 'contentScript.js'});
        }
    });
}


function pause() {
    audioCurrent.pause();
    chrome.browserAction.setBadgeText({'text': '▶'});
}

function resume() {
    audioCurrent.play();
    chrome.browserAction.setBadgeText({'text': '||'});
}

function stop(isAutomaticStop=true) {
    console.log('stop(): audioCurrentFeedEntityId:', audioCurrentFeedEntityId);

    chrome.runtime.sendMessage({
        'toPopup': {
            'playingFinished': true,
            'isAutomaticStop': isAutomaticStop
        }
    });

    // We need to clear it after error when user offline and no audioCurrent
    audioCurrentFeedEntityId = null;  // this is not always necessary but we save code from additional IF
    isPreparingPlaying = false;

    // pause audio first - against a case when next chunk suddenly appear to play.
    if (audioCurrent) {  // case when no current audio and stop() called: playing not started because limit of user ended
        audioCurrent.pause();  // when last chunk ended - no need to pause, but I think that useless action is better that IF
        audioCurrent = null;
        audio = [];
    }

    isIcoAnimating = false; // For the case when stop() called in catch()
    chrome.browserAction.setBadgeText({'text': ''});  // case: can not play (offline or 4XX or 5XX) - empty badge

    return new Promise(resolve => {
        resolve();
    });
}


/**
 * Validating of `time` against
 * `Uncaught Error:
 * Invocation of form remove(undefined) doesn't match definition remove(string or array keys, optional function callback)`
 */
function removeStubFromFeed(time) {
    if (!time) {
        return;
    }
    chrome.storage.sync.remove(`${time}`);  // arg type is string - not int
}


/**
 * @see {@link https://stackoverflow.com/questions/3847121/how-can-i-disable-all-settimeout-events}
 */
function _clearAllTimeouts() {
    const highestId = setTimeout(_ => {});
    for (let i = highestId; i > 0; i--)
        clearTimeout(i);
}

chrome.browserAction.setBadgeText({'text': ''});
/** At the end of init - reset badge.
 *  Case: user closed the browser during playing.
 */


/*
/**
 * This extension - is an event page - not persistent - this is mean that it is not always in memory
 * and when it loaded to RAM.
 * for example from some event for what we have handler - after a few seconds of inactivity extension will unloaded.
 * To prevent unloading when audio playing - we have this dummy function that do some action.
 * TODO try again without that - fix reproducagle test extension for bug report
 * TODO Firefox need it?
 * TODO query manifest.json only when not querying ogg
 * TODO replace fetch to sockets - against pollution of the network tab.
 *
 * @see {@link https://developer.chrome.com/extensions/event_pages}
 * @see {@link https://bugs.chromium.org/p/chromium/issues/detail?id=740097|
 *     opened bug that event page unloaded when audio playing}
 */
function _doNotSleep() {
    if (audioCurrent) {
        setTimeout(_ => {
            fetch(chrome.runtime.getURL('manifest.json'));    // only some http request, neither console.log() nor creating obj
            _doNotSleep();
        }, 2000);
    }
}
